﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Scripting.Hosting;
using IronPython.Hosting;

namespace ConsoleApplication7
{
    class PolicyService
    {
        public static object GetValue(Aspect aspect, object data)
        {
            string ironPythonExpression = string.Empty;
            if (aspect.AspectEnum == AspectEnum.AnnualLeave)
            {
                ironPythonExpression = @"
def MyFunction():
    if(data.EnterDays>365 or data.Position==1):
        return 5+data.EnterDays/365-1
    else:
        return 0
                ";
            }
            else if (aspect.AspectEnum == AspectEnum.EmployeeNum)
            {
                ironPythonExpression = @"
def MyFunction():
    return data.Name+str(data.Id)
                ";
            }

            Policy policy = new Policy(ironPythonExpression);

            return policy.Compute(data);
        }
        
    }
    class Policy
    {
        private string ironPythonExpression;
        public object Compute(object data)
        {
            ScriptEngine engine = Python.CreateEngine();
            ScriptScope scope = engine.CreateScope();
            scope.SetVariable("data", data);
            var sourceCode = engine.CreateScriptSourceFromString(ironPythonExpression).Compile().Execute(scope);

            var func = engine.GetVariable<Func<object>>(scope, "MyFunction");

            return func();

            
        }
        public Policy(string ironPythonExpression)
        {
            this.ironPythonExpression = ironPythonExpression;
        }
    }
    
}
